package be.iminds.ilabt.jfed.experimenter_gui.timeline.view;

import be.iminds.ilabt.jfed.experimenter_gui.editor.ModelRspecEditor;
import be.iminds.ilabt.jfed.experimenter_gui.slice.NodePropertiesDialogFactory;
import be.iminds.ilabt.jfed.experimenter_gui.timeline.model.TimelineModelFactory;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.gui_preferences.JFedHLPreferences;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 1/29/2015
 * Time: 16:55
 */
@Singleton
public class TimelineViewFactory {
    @Nonnull private final NodePropertiesDialogFactory nodePropertiesDialogFactory;
    @Nonnull private final ImageUtil imageUtil;

    @Nonnull private final TimelineModelFactory timelineModelFactory;
    @Nonnull private final JFedHLPreferences jFedPreferences;

    @Inject
    TimelineViewFactory(@Nonnull NodePropertiesDialogFactory nodePropertiesDialogFactory,
                        @Nonnull ImageUtil imageUtil, @Nonnull TimelineModelFactory timelineModelFactory, @Nonnull JFedHLPreferences jFedPreferences) {
        this.timelineModelFactory = timelineModelFactory;
        this.nodePropertiesDialogFactory = nodePropertiesDialogFactory;
        this.imageUtil = imageUtil;
        this.jFedPreferences = jFedPreferences;
    }

    public TimelineView createControllerUI(@Nonnull ModelRspecEditor modelRspecEditor) {
        return new TimelineView(modelRspecEditor.getModelRspec(), nodePropertiesDialogFactory, imageUtil, timelineModelFactory, jFedPreferences);
    }
}
